program Trickstr;
uses WinTypes, WinProcs;

var	Gotname : Boolean;
	P1,Helpfile,Exefile : array[0..127] of Char;
	ExeResult: integer;
	rec: TOfStruct;
{$R trick16.res}

function ChangeFileExt(const FileName, Extension: string): string;
var
  I: Integer;
begin
  I := Length(FileName);
  while (I > 0) and not (FileName[I] in ['.', '\', ':']) do Dec(I);
  if (I = 0) or (FileName[I] <> '.') then I := MaxInt;
  Result := Copy(FileName, 1, I - 1) + Extension;
end;

function StrPas(Str: PChar): String; assembler;
asm
	PUSH	DS
	CLD
	LES	DI,Str
	MOV	CX,0FFFFH
	XOR	AL,AL
	REPNE	SCASB
	NOT	CX
	DEC	CX
	LDS	SI,Str
	LES	DI,@Result
	MOV	AL,CL
	STOSB
	REP	MOVSB
	POP	DS
end;


function ExtractFileName(const FileName: string): string;
var
  I: Integer;
begin
  I := Length(FileName);
  while (I > 0) and not (FileName[I] in ['\', ':']) do Dec(I);
  Result := Copy(FileName, I + 1, 255);
end;

function StrPCopy(Dest: PChar; Source: String): PChar; assembler;
asm
	PUSH	DS
	CLD
	LDS	SI,Source
	LES	DI,Dest
	MOV	BX,DI
	MOV	DX,ES
	LODSB
	XOR	AH,AH
	XCHG	AX,CX
	REP	MOVSB
	XOR	AL,AL
	STOSB
	XCHG	AX,BX
	POP	DS
end;



begin
	Gotname := False;

{Fetch .EXE filename}
	GetModuleFileName(GetModuleHandle('TRICKSTR'), Exefile, SizeOf(ExeFile)+1);
	StrPCopy(ExeFile,{'./' + }ExtractFilename(StrPas(ExeFile)));

{Get helpfile...}
	StrPCopy(ExeFile,ExtractFilename(ExeFile));
	StrPCopy(Helpfile,ChangeFileExt(StrPas(ExeFile),'.HLP'));
{Get helpfile...}
	 If OpenFile(Helpfile, rec, OF_EXIST) <> HFILE_ERROR Then begin

{...and execute winhelp}
		Gotname := True;
		StrPCopy(P1, 'winhelp.exe ' + ChangeFileExt(StrPas(ExeFile),'.HLP'));
		ExeResult := WinExec(P1,SW_SHOWNORMAL);
		end;
{Report error if file not found or executable}
	If (ExeResult < 32) or (Gotname = false) Then begin
		StrPCopy(P1,'Unexpected launcher error.'+#10+'The ' +StrPas(Helpfile)+
			' file may be corrupt, missing or located on an inaccessible drive or partition.');
		Messagebox(0,P1,'Unable to launch',16);
		end;
end.

