unit Styler1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, lrsbmp16,StrRes,Rzlabel, StdCtrls, ExtCtrls, Balloon;

type
  TMainmenu = class(TForm)
	Bevel1: TBevel;
	GroupBox2: TGroupBox;
	WHMB1: TButton;
	LrsBmp1: TLrsBmp;
	LrsBmp2: TLrsBmp;
	RzLabel1: TRzLabel;
	Label1: TLabel;
	Label2: TLabel;
	Quitbutton: TButton;
	BalloonHint1: TBalloonHint;
	Button1: TButton;
    Button2: TButton;
	procedure QuitbuttonClick(Sender: TObject);
	procedure FormCreate(Sender: TObject);
	procedure WHMB1Click(Sender: TObject);
	procedure Button1Click(Sender: TObject);
  private
	{ Private declarations }
	procedure AppInit;
  public
	{ Public declarations }
  end;

Var
	Mainmenu: TMainmenu;
	INIFile,Retstring: array [0..255] of Char;
	Section: array [0..25] of Char;

implementation

{$R *.DFM}

uses THMBCode,MBESamp;

procedure TMainmenu.FormCreate(Sender: TObject);
var P1: array [0..99] of Char;
begin
	Font.Name := 'System';
	Application.ShowHint := True;
	AppInit;
end;

procedure TMainmenu.AppInit;
begin
	StrPCopy(INIFile, ChangeFileExt(Application.ExeName,'.INI'));
	StrPCopy(Section, 'Defaults');
End;

procedure TMainmenu.QuitbuttonClick(Sender: TObject);
begin
	Close;
end;


procedure TMainmenu.WHMB1Click(Sender: TObject);
var box : TTHMB;
begin
		box := TTHMB.Create(Application);
		Mainmenu.Hide;
		box.Showmodal;
		Mainmenu.Show;
		box.Free;
end;


procedure TMainmenu.Button1Click(Sender: TObject);
var box : TMBEnh;
	i1 : integer;
	Warnstring: array [0..5] of Char;
begin
	GetPrivateProfileString('Defaults','WHMBEWarn','',Warnstring,SizeOf(Warnstring),Inifile);
	If StrPas(Warnstring) <> StrPas('OFF') then begin
		i1 :=MessageBox(Self.Handle,'WHMBE()''s preview mode will only '
			+'show your custom icons if they are stored in WH16FACE.DLL.'
			+'The macro can display icons in WH32FACE.DLL, but it cannot '
			+'preview them from this 16 bit interface.' + #10#10
			+'Disable future display of this warning?','Custom icon warning',
			+MB_YESNO + MB_ICONQUESTION);
		if i1 = ID_YES then WritePrivateProfileString('Defaults','WHMBEWarn','OFF',INIFile);
	end;
	box := TMBEnh.Create(Application);
	Mainmenu.Hide;
	box.Showmodal;
	Mainmenu.Show;
	box.Free;
end;

end.
